Loading...
Searching...
No Matches
log4shib::FixedContextCategory Class Reference

This Category subclass replaces the NDC field in LoggingEvents with a fixed context string. More...

`#include <FixedContextCategory.hh>`

Inheritance diagram for log4shib::FixedContextCategory:
[legend]
Collaboration diagram for log4shib::FixedContextCategory:
[legend]

## Public Member Functions

| FixedContextCategory (const std::string &name, const std::string &context="")
| Constructor.
virtual | ~FixedContextCategory ()
| Destructor for Category.
virtual void | setContext (const std::string &context)
| Set the context string used as NDC.
virtual std::string | getContext () const
| Return the context string used as NDC.
virtual Priority::Value | getPriority () const throw ()
| Returns the assigned Priority, if any, for this Category.
virtual Priority::Value | getChainedPriority () const throw ()
| Starting from this Category, search the category hierarchy for a set priority and return it.
virtual void | addAppender (Appender *appender) throw ()
| For the moment this method does nothing.
virtual void | addAppender (Appender &appender)
| For the moment this method does nothing.
virtual Appender * | getAppender () const
| Returns the Appender for this Category, or NULL if no Appender has been set.
virtual Appender * | getAppender (const std::string &name) const
| Returns the specified Appender for this Category, or NULL if the Appender is not attached to this Category.
virtual AppenderSet | getAllAppenders () const
| Returns the set of Appenders currently attached to this Catogory.
virtual void | removeAllAppenders ()
| Removes all appenders set for this Category.
virtual bool | ownsAppender (Appender *appender) const throw ()
| FixedContextAppenders cannot own Appenders.
virtual void | callAppenders (const LoggingEvent &event) throw ()
| Call the appenders in the hierarchy starting at `this`.
virtual void | setAdditivity (bool additivity)
| Set the additivity flag for this Category instance.
virtual bool | getAdditivity () const throw ()
| Returns the additivity flag for this Category instance.
Public Member Functions inherited from log4shib::Category
virtual | ~Category ()
| Destructor for Category.
virtual const std::string & | getName () const throw ()
| Return the category name.
virtual void | setPriority (Priority::Value priority)
| Set the priority of this Category.
virtual bool | isPriorityEnabled (Priority::Value priority) const throw ()
| Returns true if the chained priority of the Category is equal to or higher than given priority.
void | setAppender (Appender *appender)
| Adds an Appender to this Category.
void | setAppender (Appender &appender)
| Adds an Appender for this Category.
virtual void | removeAppender (Appender *appender)
| Removes specified appender for this Category.
bool | ownsAppender () const throw ()
| Returns true if the Category owns the first Appender in its Appender set.
virtual Category * | getParent () throw ()
| Returns the parent category of this category, or NULL if the category is the root category.
virtual const Category * | getParent () const throw ()
| Returns the parent category of this category, or NULL if the category is the root category.
virtual void | log (Priority::Value priority, const char *stringFormat,...) throw ()
| Log a message with the specified priority.
virtual void | log (Priority::Value priority, const std::string &message) throw ()
| Log a message with the specified priority.
virtual void | logva (Priority::Value priority, const char *stringFormat, va_list va) throw ()
| Log a message with the specified priority.
void | debug (const char *stringFormat,...) throw ()
| Log a message with debug priority.
void | debug (const std::string &message) throw ()
| Log a message with debug priority.
bool | isDebugEnabled () const throw ()
| Return true if the Category will log messages with priority DEBUG.
CategoryStream | debugStream ()
| Return a CategoryStream with priority DEBUG.
void | info (const char *stringFormat,...) throw ()
| Log a message with info priority.
void | info (const std::string &message) throw ()
| Log a message with info priority.
bool | isInfoEnabled () const throw ()
| Return true if the Category will log messages with priority INFO.
CategoryStream | infoStream ()
| Return a CategoryStream with priority INFO.
void | notice (const char *stringFormat,...) throw ()
| Log a message with notice priority.
void | notice (const std::string &message) throw ()
| Log a message with notice priority.
bool | isNoticeEnabled () const throw ()
| Return true if the Category will log messages with priority NOTICE.
CategoryStream | noticeStream ()
| Return a CategoryStream with priority NOTICE.
void | warn (const char *stringFormat,...) throw ()
| Log a message with warn priority.
void | warn (const std::string &message) throw ()
| Log a message with warn priority.
bool | isWarnEnabled () const throw ()
| Return true if the Category will log messages with priority WARN.
CategoryStream | warnStream ()
| Return a CategoryStream with priority WARN.
void | error (const char *stringFormat,...) throw ()
| Log a message with error priority.
void | error (const std::string &message) throw ()
| Log a message with error priority.
bool | isErrorEnabled () const throw ()
| Return true if the Category will log messages with priority ERROR.
CategoryStream | errorStream ()
| Return a CategoryStream with priority ERROR.
void | crit (const char *stringFormat,...) throw ()
| Log a message with crit priority.
void | crit (const std::string &message) throw ()
| Log a message with crit priority.
bool | isCritEnabled () const throw ()
| Return true if the Category will log messages with priority CRIT.
CategoryStream | critStream ()
| Return a CategoryStream with priority CRIT.
void | alert (const char *stringFormat,...) throw ()
| Log a message with alert priority.
void | alert (const std::string &message) throw ()
| Log a message with alert priority.
bool | isAlertEnabled () const throw ()
| Return true if the Category will log messages with priority ALERT.
CategoryStream | alertStream () throw ()
| Return a CategoryStream with priority ALERT.
void | emerg (const char *stringFormat,...) throw ()
| Log a message with emerg priority.
void | emerg (const std::string &message) throw ()
| Log a message with emerg priority.
bool | isEmergEnabled () const throw ()
| Return true if the Category will log messages with priority EMERG.
CategoryStream | emergStream ()
| Return a CategoryStream with priority EMERG.
void | fatal (const char *stringFormat,...) throw ()
| Log a message with fatal priority.
void | fatal (const std::string &message) throw ()
| Log a message with fatal priority.
bool | isFatalEnabled () const throw ()
| Return true if the Category will log messages with priority FATAL.
CategoryStream | fatalStream ()
| Return a CategoryStream with priority FATAL.
virtual CategoryStream | getStream (Priority::Value priority)
| Return a CategoryStream with given Priority.
virtual CategoryStream | operator<< (Priority::Value priority)
| Return a CategoryStream with given Priority.

## Protected Member Functions

virtual void | _logUnconditionally2 (Priority::Value priority, const std::string &message) throw ()
| Unconditionally log a message with the specified priority.
Protected Member Functions inherited from log4shib::Category
| Category (const std::string &name, Category *parent, Priority::Value priority=Priority::NOTSET)
| Constructor.
virtual void | _logUnconditionally (Priority::Value priority, const char *format, va_list arguments) throw ()

## Additional Inherited Members

Static Public Member Functions inherited from log4shib::Category
static Category & | getRoot ()
| Return the root of the Category hierarchy.
static void | setRootPriority (Priority::Value priority)
| Set the priority of the root Category.
static Priority::Value | getRootPriority () throw ()
| Get the priority of the `root` Category.
static Category & | getInstance (const std::string &name)
| Instantiate a Category with name `name`.
static Category * | exists (const std::string &name)
| If the named category exists (in the default hierarchy) then it returns a reference to the category, otherwise it returns NULL.
static std::vector< Category * > * | getCurrentCategories ()
| Returns all the currently defined categories as a vector of Category pointers.
static void | shutdown ()
| This method will remove all Appenders from Categories.XXX.

## Detailed Description

This Category subclass replaces the NDC field in LoggingEvents with a fixed context string.

All handling of Appenders, etc. is delgated to the 'normal' Category with the same name. Its intended use is for object instances that serve a single client: they contruct a FixedContextCategory with the client identifier as context. Unlike with regular Category instances one has to explicitly create FixedContextCategory instances using the constructor. This also implies one has to take cake of destruction of the instance as well.

Since
  0.2.4

## Constructor & Destructor Documentation

## FixedContextCategory()

log4shib::FixedContextCategory::FixedContextCategory | ( | const std::string & | name,
|  | const std::string & | context = "" )

Constructor.

Parameters

  name | the fully qualified name of this Categories delegate Category.
  context | the context to fill the NDC field of LoggingEvents with.

## ~FixedContextCategory()

log4shib::FixedContextCategory::~FixedContextCategory | ( |  | ) |

virtual

Destructor for Category.

## Member Function Documentation

## _logUnconditionally2()

void log4shib::FixedContextCategory::_logUnconditionally2 | ( | Priority::Value | priority,
|  | const std::string & | message )
throw | ( | ) |  |  |

protected virtual

Unconditionally log a message with the specified priority.

Parameters

  priority | The priority of this log message.
  message | string to write in the log file

Reimplemented from log4shib::Category.

## addAppender() [1/2]

void log4shib::FixedContextCategory::addAppender | ( | Appender & | appender | ) |

virtual

For the moment this method does nothing.

Reimplemented from log4shib::Category.

## addAppender() [2/2]

void log4shib::FixedContextCategory::addAppender | ( | Appender * | appender | ) |
throw | ( | ) |  |  |

virtual

For the moment this method does nothing.

Reimplemented from log4shib::Category.

## callAppenders()

void log4shib::FixedContextCategory::callAppenders | ( | const LoggingEvent & | event | ) |
throw | ( | ) |  |  |

virtual

Call the appenders in the hierarchy starting at `this`.

If no appenders could be found, emit a warning.

This method always calls all the appenders inherited form the hierracy circumventing any evaluation of whether to log or not to log the particular log request.

Parameters

  event | The LoggingEvent to log.

Reimplemented from log4shib::Category.

## getAdditivity()

bool log4shib::FixedContextCategory::getAdditivity | ( |  | ) | const
throw | ( | ) |  |  |

virtual

Returns the additivity flag for this Category instance.

Reimplemented from log4shib::Category.

## getAllAppenders()

AppenderSet log4shib::FixedContextCategory::getAllAppenders | ( |  | ) | const

virtual

Returns the set of Appenders currently attached to this Catogory.

Since
  0.3.1

Returns
  The set of attached Appenders.

Reimplemented from log4shib::Category.

## getAppender() [1/2]

Appender * log4shib::FixedContextCategory::getAppender | ( |  | ) | const

virtual

Returns the Appender for this Category, or NULL if no Appender has been set.

Returns
  The Appender.

Reimplemented from log4shib::Category.

## getAppender() [2/2]

Appender * log4shib::FixedContextCategory::getAppender | ( | const std::string & | name | ) | const

virtual

Returns the specified Appender for this Category, or NULL if the Appender is not attached to this Category.

Since
  0.2.7

Returns
  The Appender.

Reimplemented from log4shib::Category.

## getChainedPriority()

Priority::Value log4shib::FixedContextCategory::getChainedPriority | ( |  | ) | const
throw | ( | ) |  |  |

virtual

Starting from this Category, search the category hierarchy for a set priority and return it.

Otherwise, return the priority of the root category.

The Category class is designed so that this method executes as quickly as possible.

Reimplemented from log4shib::Category.

## getContext()

std::string log4shib::FixedContextCategory::getContext | ( |  | ) | const

virtual

Return the context string used as NDC.

Returns
  the context string.

## getPriority()

Priority::Value log4shib::FixedContextCategory::getPriority | ( |  | ) | const
throw | ( | ) |  |  |

virtual

Returns the assigned Priority, if any, for this Category.

Returns
  Priority - the assigned Priority, can be Priority::NOTSET

Reimplemented from log4shib::Category.

## ownsAppender()

bool log4shib::FixedContextCategory::ownsAppender | ( | Appender * | appender | ) | const
throw | ( | ) |  |  |

virtual

FixedContextAppenders cannot own Appenders.

Returns
  false

Reimplemented from log4shib::Category.

## removeAllAppenders()

void log4shib::FixedContextCategory::removeAllAppenders | ( |  | ) |

virtual

Removes all appenders set for this Category.

Currently a Category can have only one appender, but this may change in the future.

Reimplemented from log4shib::Category.

## setAdditivity()

void log4shib::FixedContextCategory::setAdditivity | ( | bool | additivity | ) |

virtual

Set the additivity flag for this Category instance.

Reimplemented from log4shib::Category.

## setContext()

void log4shib::FixedContextCategory::setContext | ( | const std::string & | context | ) |

virtual

Set the context string used as NDC.

Parameters

  context | the context string

The documentation for this class was generated from the following files:

- FixedContextCategory.hh
- FixedContextCategory.cpp